/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0S/Kx1+
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2012
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0S/Kx1+ V2.41 [9 Sep. 2008]
**
**  Device :	uPD78F9212
**
**  Compiler :	CC78K0S
**
**  Creation date:	2012/01/11
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "port.h"
#include "int.h"
#include "timer.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/

#define SERVO1					P4.0
#define SERVO2					P4.1
#define SERVO3					P4.2

#define SERVO1_LED1				P4.3
#define	SERVO1_LED2				P4.4
#define SERVO2_LED1				P2.2
#define SERVO2_LED2				P4.6
#define SERVO3_LED1				P4.5
#define SERVO3_LED2				P2.3


unsigned char	servo1_count;
unsigned char	servo1_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo1_on;
unsigned char	servo1_n;

unsigned char	servo2_count;
unsigned char	servo2_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo2_on;
unsigned char	servo2_n;

unsigned char	servo3_count;
unsigned char	servo3_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo3_on;
unsigned char	servo3_n;

 unsigned char	timer_20;

unsigned char	data_ch;

unsigned char	in_data;

unsigned char	count;
unsigned int	rec[12];
unsigned char	count10_flg;
unsigned char	receive_err;
unsigned int	receive_no;


void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}

/*---------- receive signal check ----------*/
void	receive_hantei10(void){

	receive_err=0;
	if((rec[1]>=2000)&&(rec[1]<=2500)){}else{receive_err=1;return;}
	/*P2.2=0;P4.6=0;*/
	receive_no=0;
	if((rec[2]>=1100)&(rec[2]<=1400)){receive_no=receive_no | 0x01;}
	if((rec[3]>=1100)&(rec[3]<=1400)){receive_no=receive_no | 0x02;}
	if((rec[4]>=1100)&(rec[4]<=1400)){receive_no=receive_no | 0x04;}
	if((rec[5]>=1100)&(rec[5]<=1400)){receive_no=receive_no | 0x08;}
	if((rec[6]>=1100)&(rec[6]<=1400)){receive_no=receive_no | 0x10;}
	if((rec[7]>=1100)&(rec[7]<=1400)){receive_no=receive_no | 0x20;}
	if((rec[8]>=1100)&(rec[8]<=1400)){receive_no=receive_no | 0x40;}
	if((rec[9]>=1100)&(rec[9]<=1400)){receive_no=receive_no | 0x80;}

}


/*---------- MAIN ----------*/
void  main( void )
{

	servo1_n=0;SERVO1_LED1=0;SERVO1_LED2=1;
	servo1_count=servo1_set[servo1_n];
	servo1_on=0;

	servo2_n=0;SERVO2_LED1=1;SERVO2_LED2=0;
	servo2_count=servo2_set[servo2_n];
	servo2_on=0;

	servo3_n=0;SERVO3_LED1=0;SERVO3_LED2=1;
	servo3_count=servo3_set[servo3_n];
	servo3_on=0;

	timer_20=0;
	count10_flg=0;

	TMH1_Start();
	TM00_Start();
	INTP1_Enable();

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */


		/*wait_time(200);*/


	/* key scan 2 */


	/* action */


	/* receive data hantei */
	
		if(count10_flg==1){
			count10_flg=0;
			receive_hantei10();
			if(receive_err==0){

				switch(receive_no){
					
					case 0x30:	servo1_n=1;SERVO1_LED1=1;SERVO1_LED2=0;
								break;
					case 0x31:	servo1_n=0;SERVO1_LED1=0;SERVO1_LED2=1;
								break;
					case 0x32:	servo2_n=1;SERVO2_LED1=0;SERVO2_LED2=1;
								break;
					case 0x33:	servo2_n=0;SERVO2_LED1=1;SERVO2_LED2=0;
								break;
					case 0x34:	servo3_n=1;SERVO3_LED1=1;SERVO3_LED2=0;
								break;
					case 0x35:	servo3_n=0;SERVO3_LED1=0;SERVO3_LED2=1;
								break;
				}
				
			}
		}
				

	/*------------------*/
	
	
	
	
	
	
	
		;
	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */



